#ifndef E_NAME_H
#define E_NAME_H
#include <stdio.h>

extern e_obj_descriptor e_obj_descriptor_name;
#define E_IS_NAME (E_OBJ_DESCR(P) == e_obj_descriptor_name)
#define E_TYPE_NAME (&e_obj_descriptor_name)

/* Must be smaller than 2^24 */
#define E_NAME_TABLE_SIZE 4001

typedef struct {
  e_obj h;         /* object header                       */
  char *name;      /* The actual name                     */  
  int len;         /* The name len : buff size is len +1  */
  int hash;        /* Open mode                           */
  void *val;       /* Global value                        */
  void *next;      /* next name wih the same hash values  */
} e_name;

int e_name_init(void *p);
e_name *e_name_new(char *name);
void e_name_free(void *fp);
void *e_name_to_string(void *fp,int tab,e_flag mode);
void *e_name_clone(void *fp,e_flag mode);
int e_name_equals(void *p1,void *p2);
e_name *e_name_find_name(char *s);
int e_name_set_val(e_name *np,void *val);
void *e_name_get_val(e_name *np);
int e_name_hash(char *s, int hashsize);

#define E_NAME_NAME(P) (((e_name *)P)->name)
#define E_NAME_LEN(P) (((e_name *)P)->len)
#define E_NAME_HASH(P) (((e_name *)P)->hash)
#define E_NAME_VAL(P) (((e_name *)P)->val)

#endif
