#ifndef E_NUMBER_H
#define E_NUMBER_H
#include <stdio.h>

extern e_obj_descriptor e_obj_descriptor_number;
#define E_IS_NUMBER (E_OBJ_DESCR(P) == e_obj_descriptor_number)
#define E_TYPE_NUMBER (&e_obj_descriptor_number)

#define E_NUM_TYPE_CHAR  1
#define E_NUM_TYPE_INT   2
#define E_NUM_TYPE_REAL  3
#define E_NUM_TYPE_COMP  4

typedef struct {
  double re;
  double im;
} comp;

typedef union {
  char ch;
  int i;
  double r;
  comp c;
} e_num;

typedef struct {
  e_obj h;         /* object header                   */
  int type;
  e_num val; 
} e_number;

e_number *e_number_new(e_number *np,int type, int init);
void e_number_free(void *np);
void *e_number_to_string(void *np,int tab,e_flag mode);
void *e_number_clone(void *np,e_flag mode);
int e_number_equals(void *p1,void *p2);

#define E_NUMBER_FILENAME(P) (((e_number *)P)->file_name)
#define E_NUMBER_VAL(P) (((e_number *)P)->val)
#define E_NUMBER_TYPE(P) (((e_number *)P)->type)

#define E_NUMBER_VAL_CHAR(P) (((e_number *)P)->val.ch)
#define E_NUMBER_VAL_INT(P) (((e_number *)P)->val.i)
#define E_NUMBER_VAL_REAL(P) (((e_number *)P)->val.r)
#define E_NUMBER_VAL_COMP(P) (((e_number *)P)->val.c)

#endif
