#ifndef E_STRING_H
#define E_STRING_H

typedef struct {
  e_obj h;      /* object header                             */
  char *s;      /* pointer to an dynamicaly allocated string */
  int size;     /* size of allocated buffer                  */         
  int len;      /* lenght of the string                      */   
  int index;    /* index in the string                       */
} e_string;

extern e_obj_descriptor e_obj_descriptor_string;
#define E_IS_STRING (E_OBJ_DESCR(P) == e_obj_descriptor_string)
#define E_TYPE_STRING (&e_obj_descriptor_string)

#define E_STRING(P) ((e_string *)P)
#define E_STRING_S(P) (((e_string *)P)->s)
#define E_STRING_SIZE(P) (((e_string *)P)->size)
#define E_STRING_LEN(P) (((e_string *)P)->len)
#define E_STRING_INDEX(P) (((e_string *)P)->index)


int e_string_init(void *p);
e_string *e_string_new(e_string *stp,char *s, int size);
int e_string_resize(e_string *stp,int size);
void e_string_free(void *stp);
void *e_string_to_string(void *str,int tab,e_flag mode);
void *e_string_clone(void *stp,e_flag mode);
int  e_string_equals(void *p1,void *p2);
void e_string_set_index(e_string *stp, int index);
int e_string_get(e_string *stp,int pos);
int e_string_put(e_string *stp,char c, int pos);
int e_string_append_char(e_string *stp,char c);
int e_string_iget(e_string *stp);
int e_string_iput(e_string *stp,char c);
e_string *e_string_insert_chars(e_string *stp,int pos, int n,char c);
e_string *e_string_insert_string(e_string *stp,e_string *stp2,int pos);
e_string *e_string_delete(e_string *stp,int pos,int n);
e_string *e_string_quote(e_string *stp);
e_string *e_string_append_buffer(e_string *stp,char *str);
e_string *e_string_append_string(e_string *stp,e_string *stp2);

/* to add : insert and delete functions */

#endif
